import pygame,sys
from player import Player, Button

#game initialization
pygame.init()
W, H = 960, 540
screen = pygame.display.set_mode((W, H),pygame.RESIZABLE)
pygame.display.set_caption('ProjetNSI')
clock = pygame.time.Clock()

#######################################################

 #clock
timer = 60
minutes = 2
seconds = 12
font = pygame.font.SysFont(None, 60)
font2 = pygame.font.SysFont(None, 100)
img = font.render(f"{minutes}:{seconds}", True, '#FFFFFF' ) 

#Load images
background = pygame.image.load('assets/background.png')
background = pygame.transform.scale(background, (W, H))
menuBackground = pygame.image.load("assets/menuBackground.png")

#draw health bar
def drawHB(health, x, y):
  pygame.draw.rect(screen, (255,255,255), (x - 2, y - 2, 354, 29))
  pygame.draw.rect(screen, (255,0,0), (x, y, 350, 25))
  pygame.draw.rect(screen, (0,255,0), (x, y, health * 3.5, 25))

#Font
def get_font(size): 
  return pygame.font.Font("assets/font (1).ttf", size)

#Create instances of players
player1 = Player(1, 200, H - 180)
player2 = Player(2, 700, H - 180)

#######################################################

def play():

  #clock
  timer = 60
  minutes = 2
  seconds = 12
  font = pygame.font.SysFont(None, 60)
  font2 = pygame.font.SysFont(None, 100)
  img = font.render(f"{minutes}:{seconds}", True, '#FFFFFF' ) 

  #Load images
  background = pygame.image.load('assets/background.png')
  background = pygame.transform.scale(background, (W, H))
  menuBackground = pygame.image.load("assets/menuBackground.png")

  pause = False
  run = True
  #game loop
  while run:
    #Quit main loop
    for event in pygame.event.get():
      if event.type == pygame.QUIT:
          run = False
      if event.type == pygame.KEYDOWN:
        if event.key==pygame.K_p:
          print("pause")
          pauseImg = font2.render("PAUSE", True, (255, 255, 255))
          screen.blit(pauseImg, ((W/2)-120, (H/2) - 20))
          pygame.display.update()
          if pause == False:
            pause = True
          else:
            pause = False

    ################
    
    #move fighters
    if pause == False:

      player1.move(W, H, screen, player2)
      player2.move(W, H, screen, player1)
      
      #draw fighters
      player1.draw(screen)
      player2.draw(screen)

      #player stats
      drawHB(player1.health, 20, 20)
      drawHB(player2.health, 590, 20)
        
      #timer
      timer -= 1
      if timer == 0:
        if seconds == 0:
          minutes -= 1
          seconds = 59
        else:
          seconds -= 1
        img = font.render(f"{minutes}:{seconds}", True, '#FFFFFF' )
        timer = 60
        if minutes == 0 and seconds == 0:
          run = False
        if seconds < 10:
          img = font.render(f"{minutes}:0{seconds}", True, '#FFFFFF' )
      screen.blit(img, ((W/2)-35, H-(H-15)))

      #end game
      if player1.health <= 0 or player2.health <= 0:
        mainMenu()

      ################

      pygame.display.update()
      screen.blit(background,(0,0))
      clock.tick(60)

def mainMenu():
   while True:
        screen.blit(menuBackground, (0, 0))

        MENU_MOUSE_POS = pygame.mouse.get_pos()

        MENU_TEXT = get_font(50).render("SMASH DUO BATTLE", True, "#b68f40")
        MENU_RECT = MENU_TEXT.get_rect(center=(W/2, 100))

        PLAY_BUTTON = Button(image=pygame.image.load("assets/Play Rect.png"), pos=(W/2, 250), 
                            text_input="PLAY", font=get_font(35), base_color="#d7fcd4", hovering_color="White")
        QUIT_BUTTON = Button(image=pygame.image.load("assets/Quit Rect.png"), pos=(W/2, 350), 
                            text_input="QUIT", font=get_font(35), base_color="#d7fcd4", hovering_color="White")

        screen.blit(MENU_TEXT, MENU_RECT)

        for button in [PLAY_BUTTON, QUIT_BUTTON]:
            button.changeColor(MENU_MOUSE_POS)
            button.update(screen)
        
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                sys.exit()
            if event.type == pygame.MOUSEBUTTONDOWN:
                if PLAY_BUTTON.checkForInput(MENU_MOUSE_POS):
                    play()
                if QUIT_BUTTON.checkForInput(MENU_MOUSE_POS):
                    pygame.quit()
                    sys.exit()

        pygame.display.update()

#######################################################

mainMenu()

#Kill modules
pygame.quit()
sys.exit()
